module ApplicationHelper

  def title(blog_title)
    content_for(:title) { blog_title }
  end

  def meta_description(blog_text)
    content_for(:meta_description) { blog_text }
  end

require 'redcarpet'
require 'rouge'
require 'rouge/plugins/redcarpet'

class CodeRayify < Redcarpet::Render::HTML
  def block_code(code, language)
    CodeRay.scan(code, language).div
  end
end

def markdown(text)
  coderayified = CodeRayify.new(:filter_html => true, 
                                :hard_wrap => true)
  options = {
    :fenced_code_blocks => true,
    :no_intra_emphasis => true,
    :autolink => true,
    :lax_html_blocks => true,
  }
  markdown_to_html = Redcarpet::Markdown.new(coderayified, options)
  markdown_to_html.render(text).html_safe
end
end